package example;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.ObjectOutputStream;

import step.*;
import step.io.*;

public class StepToJavaSerial
{
  public static final int BUF_SIZE = 65536;

  public static void main(String[] args)
  {
    try
    {
      InputStream is = (args.length >= 1) ?
        (InputStream) new java.io.FileInputStream(args[0]) :
        (InputStream) System.in;

      StepRecordInput stepIn =
        new StepEncodedInput(
        new java.io.BufferedInputStream(is, BUF_SIZE));

      OutputStream os = (args.length >= 1) ?
        (OutputStream) new java.io.FileOutputStream(args[0]+".txt") :
        (OutputStream) System.out;

      StepRecordOutput stepOut =
        new StepSerialOutput(new ObjectOutputStream(os));

      long count = 0L;
      try
      {
        while (true)
        {
          StepRecord record = stepIn.readRecord();

          if ( record == null ) break;

          stepOut.writeRecord(record);

          count++;

          if ( (count % 10000L) == 0 )
            System.err.print('.');
        }
      }
      finally
      {
        System.err.println();
        System.err.println("decoded "+count+" events");

        stepIn.close();
        stepOut.close();
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
}
