/* STEP - An Framework for the Efficient Encoding of Trace Data
 * Copyright (C) 2002 Rhodes Brown
 *
 * STEP is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * STEP is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with STEP; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA
 */

/* STEP is distributed through the Sable Research Group at:
 * http://www.sable.mcgill.ca/step/
 */

/* Reference Version: $ProjectVersion: 0.9.2.dev.36 $ */

package step;

import step.typedef.*;

/**
 * The root of all types that may be interpreted as STEP data.
 */
public interface StepObject extends java.io.Serializable
{
  /** The unniversal type. */
  public static final Type TYPE = Type.v("");

  /**
   * Compare two STEP objects for equality.
   */
  public boolean equals(Object o);

  /**
   * Get a hash code for this object.
   * <p>
   * NOTE: All STEP objects must be hashable to support the
   * {@linkplain step.encoding.IdentifierStrategy identifier} encoding strategy.
   */
  public int hashCode();
}
