/* This file was generated by SableCC (http://www.sablecc.org/). */

package stepc.lexer;

import java.io.*;
import java.util.*;
import stepc.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TLineComment(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TExtendedComment(text, line, pos); }
    Token new3(int line, int pos) { return new TPackage(line, pos); }
    Token new4(int line, int pos) { return new TRecord(line, pos); }
    Token new5(int line, int pos) { return new TExtends(line, pos); }
    Token new6(int line, int pos) { return new TInt(line, pos); }
    Token new7(int line, int pos) { return new TData(line, pos); }
    Token new8(int line, int pos) { return new TString(line, pos); }
    Token new9(int line, int pos) { return new TFloat(line, pos); }
    Token new10(int line, int pos) { return new TDot(line, pos); }
    Token new11(int line, int pos) { return new TComma(line, pos); }
    Token new12(int line, int pos) { return new TSemicolon(line, pos); }
    Token new13(int line, int pos) { return new TColon(line, pos); }
    Token new14(int line, int pos) { return new TLBrace(line, pos); }
    Token new15(int line, int pos) { return new TRBrace(line, pos); }
    Token new16(int line, int pos) { return new TLBracket(line, pos); }
    Token new17(int line, int pos) { return new TRBracket(line, pos); }
    Token new18(int line, int pos) { return new TLt(line, pos); }
    Token new19(int line, int pos) { return new TGt(line, pos); }
    Token new20(int line, int pos) { return new TBang(line, pos); }
    Token new21(int line, int pos) { return new TTilde(line, pos); }
    Token new22(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new23(String text, int line, int pos) { return new TStringLiteral(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {35, 35, 7}, {44, 44, 8}, {46, 46, 9}, {47, 47, 10}, {58, 58, 11}, {59, 59, 12}, {60, 60, 13}, {62, 62, 14}, {65, 90, 15}, {91, 91, 16}, {93, 93, 17}, {95, 95, 18}, {97, 99, 15}, {100, 100, 19}, {101, 101, 20}, {102, 102, 21}, {103, 104, 15}, {105, 105, 22}, {106, 111, 15}, {112, 112, 23}, {113, 113, 15}, {114, 114, 24}, {115, 115, 25}, {116, 122, 15}, {123, 123, 26}, {125, 125, 27}, {126, 126, 28}, },
            {},
            {},
            {},
            {},
            {},
            {{9, 9, 29}, {32, 33, 29}, {34, 34, 30}, {35, 91, 29}, {92, 92, 31}, {93, 126, 29}, },
            {{0, 9, 32}, {11, 12, 32}, {14, 127, 32}, },
            {},
            {},
            {{42, 42, 33}, {47, 47, 34}, },
            {},
            {},
            {},
            {},
            {{48, 57, 35}, {65, 90, 36}, {95, 95, 37}, {97, 122, 36}, },
            {},
            {},
            {{48, 122, -17}, },
            {{48, 95, -17}, {97, 97, 38}, {98, 122, 36}, },
            {{48, 95, -17}, {97, 119, 36}, {120, 120, 39}, {121, 122, 36}, },
            {{48, 95, -17}, {97, 107, 36}, {108, 108, 40}, {109, 122, 36}, },
            {{48, 95, -17}, {97, 109, 36}, {110, 110, 41}, {111, 122, 36}, },
            {{48, 95, -17}, {97, 97, 42}, {98, 122, 36}, },
            {{48, 95, -17}, {97, 100, 36}, {101, 101, 43}, {102, 122, 36}, },
            {{48, 95, -17}, {97, 115, 36}, {116, 116, 44}, {117, 122, 36}, },
            {},
            {},
            {},
            {{9, 126, -8}, },
            {},
            {{9, 9, 45}, {32, 126, 45}, },
            {{0, 127, -9}, },
            {{0, 41, 46}, {42, 42, 47}, {43, 127, 46}, },
            {{0, 127, -9}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 115, -27}, {116, 116, 48}, {117, 122, 36}, },
            {{48, 115, -27}, {116, 116, 49}, {117, 122, 36}, },
            {{48, 95, -17}, {97, 110, 36}, {111, 111, 50}, {112, 122, 36}, },
            {{48, 115, -27}, {116, 116, 51}, {117, 122, 36}, },
            {{48, 95, -17}, {97, 98, 36}, {99, 99, 52}, {100, 122, 36}, },
            {{48, 98, -44}, {99, 99, 53}, {100, 122, 36}, },
            {{48, 95, -17}, {97, 113, 36}, {114, 114, 54}, {115, 122, 36}, },
            {{9, 126, -8}, },
            {{0, 127, -35}, },
            {{0, 41, 55}, {42, 42, 47}, {43, 46, 55}, {47, 47, 56}, {48, 127, 55}, },
            {{48, 95, -17}, {97, 97, 57}, {98, 122, 36}, },
            {{48, 100, -26}, {101, 101, 58}, {102, 122, 36}, },
            {{48, 95, -17}, {97, 97, 59}, {98, 122, 36}, },
            {{48, 122, -17}, },
            {{48, 95, -17}, {97, 106, 36}, {107, 107, 60}, {108, 122, 36}, },
            {{48, 110, -42}, {111, 111, 61}, {112, 122, 36}, },
            {{48, 95, -17}, {97, 104, 36}, {105, 105, 62}, {106, 122, 36}, },
            {{0, 41, 63}, {42, 42, 64}, {43, 127, 63}, },
            {},
            {{48, 122, -17}, },
            {{48, 109, -24}, {110, 110, 65}, {111, 122, 36}, },
            {{48, 115, -27}, {116, 116, 66}, {117, 122, 36}, },
            {{48, 95, -17}, {97, 97, 67}, {98, 122, 36}, },
            {{48, 113, -46}, {114, 114, 68}, {115, 122, 36}, },
            {{48, 109, -24}, {110, 110, 69}, {111, 122, 36}, },
            {{0, 127, -57}, },
            {{0, 41, 55}, {42, 42, 64}, {43, 127, -49}, },
            {{48, 95, -17}, {97, 99, 36}, {100, 100, 70}, {101, 122, 36}, },
            {{48, 122, -17}, },
            {{48, 95, -17}, {97, 102, 36}, {103, 103, 71}, {104, 122, 36}, },
            {{48, 99, -67}, {100, 100, 72}, {101, 122, 36}, },
            {{48, 102, -69}, {103, 103, 73}, {104, 122, 36}, },
            {{48, 95, -17}, {97, 114, 36}, {115, 115, 74}, {116, 122, 36}, },
            {{48, 100, -26}, {101, 101, 75}, {102, 122, 36}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
            {{48, 122, -17}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 0, 0, 0, 0, 20, -1, 1, 11, 10, -1, 13, 12, 18, 19, 22, 16, 17, 22, 22, 22, 22, 22, 22, 22, 22, 14, 15, 21, -1, 23, -1, 1, -1, 1, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, -1, -1, -1, 22, 22, 22, 6, 22, 22, 22, -1, 2, 7, 22, 22, 22, 22, 22, -1, -1, 22, 9, 22, 22, 22, 22, 22, 4, 8, 5, 3, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
