/* This file was generated by SableCC (http://www.sablecc.org/). */

package stepc.parser;

import stepc.lexer.*;
import stepc.node.*;
import stepc.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(11), node, false); } break;
                    case 3: { Node node = new3(); push(goTo(11), node, false); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(1), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(1), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(1), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(1), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(1), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(1), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(1), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(1), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(1), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(1), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(12), node, false); } break;
                    case 16: { Node node = new16(); push(goTo(12), node, false); } break;
                    case 17: { Node node = new17(); push(goTo(1), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(1), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(1), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(1), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(1), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(1), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(1), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(1), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(13), node, false); } break;
                    case 26: { Node node = new26(); push(goTo(13), node, false); } break;
                    case 27: { Node node = new27(); push(goTo(1), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(1), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(1), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(1), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(1), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(1), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(1), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(1), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(1), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(1), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(1), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(1), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(1), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(1), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(1), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(1), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(14), node, false); } break;
                    case 44: { Node node = new44(); push(goTo(14), node, false); } break;
                    case 45: { Node node = new45(); push(goTo(1), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(1), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(1), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(1), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(1), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(1), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(1), node, true); } break;
                    case 52: { Node node = new52(); push(goTo(1), node, true); } break;
                    case 53: { Node node = new53(); push(goTo(1), node, true); } break;
                    case 54: { Node node = new54(); push(goTo(1), node, true); } break;
                    case 55: { Node node = new55(); push(goTo(1), node, true); } break;
                    case 56: { Node node = new56(); push(goTo(1), node, true); } break;
                    case 57: { Node node = new57(); push(goTo(1), node, true); } break;
                    case 58: { Node node = new58(); push(goTo(1), node, true); } break;
                    case 59: { Node node = new59(); push(goTo(1), node, true); } break;
                    case 60: { Node node = new60(); push(goTo(1), node, true); } break;
                    case 61: { Node node = new61(); push(goTo(1), node, true); } break;
                    case 62: { Node node = new62(); push(goTo(1), node, true); } break;
                    case 63: { Node node = new63(); push(goTo(1), node, true); } break;
                    case 64: { Node node = new64(); push(goTo(1), node, true); } break;
                    case 65: { Node node = new65(); push(goTo(1), node, true); } break;
                    case 66: { Node node = new66(); push(goTo(1), node, true); } break;
                    case 67: { Node node = new67(); push(goTo(1), node, true); } break;
                    case 68: { Node node = new68(); push(goTo(1), node, true); } break;
                    case 69: { Node node = new69(); push(goTo(1), node, true); } break;
                    case 70: { Node node = new70(); push(goTo(1), node, true); } break;
                    case 71: { Node node = new71(); push(goTo(1), node, true); } break;
                    case 72: { Node node = new72(); push(goTo(1), node, true); } break;
                    case 73: { Node node = new73(); push(goTo(1), node, true); } break;
                    case 74: { Node node = new74(); push(goTo(1), node, true); } break;
                    case 75: { Node node = new75(); push(goTo(1), node, true); } break;
                    case 76: { Node node = new76(); push(goTo(2), node, true); } break;
                    case 77: { Node node = new77(); push(goTo(2), node, true); } break;
                    case 78: { Node node = new78(); push(goTo(3), node, true); } break;
                    case 79: { Node node = new79(); push(goTo(3), node, true); } break;
                    case 80: { Node node = new80(); push(goTo(15), node, false); } break;
                    case 81: { Node node = new81(); push(goTo(15), node, false); } break;
                    case 82: { Node node = new82(); push(goTo(4), node, true); } break;
                    case 83: { Node node = new83(); push(goTo(5), node, true); } break;
                    case 84: { Node node = new84(); push(goTo(5), node, true); } break;
                    case 85: { Node node = new85(); push(goTo(5), node, true); } break;
                    case 86: { Node node = new86(); push(goTo(5), node, true); } break;
                    case 87: { Node node = new87(); push(goTo(6), node, true); } break;
                    case 88: { Node node = new88(); push(goTo(6), node, true); } break;
                    case 89: { Node node = new89(); push(goTo(6), node, true); } break;
                    case 90: { Node node = new90(); push(goTo(6), node, true); } break;
                    case 91: { Node node = new91(); push(goTo(7), node, true); } break;
                    case 92: { Node node = new92(); push(goTo(8), node, true); } break;
                    case 93: { Node node = new93(); push(goTo(8), node, true); } break;
                    case 94: { Node node = new94(); push(goTo(9), node, true); } break;
                    case 95: { Node node = new95(); push(goTo(9), node, true); } break;
                    case 96: { Node node = new96(); push(goTo(9), node, true); } break;
                    case 97: { Node node = new97(); push(goTo(9), node, true); } break;
                    case 98: { Node node = new98(); push(goTo(9), node, true); } break;
                    case 99: { Node node = new99(); push(goTo(9), node, true); } break;
                    case 100: { Node node = new100(); push(goTo(10), node, true); } break;
                    case 101: { Node node = new101(); push(goTo(10), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PFile node1 = (PFile) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        XPDefinition node1 = null;
        AFile node = new AFile(node1);
        return node;
    }

    Node new1()
    {
        XPDefinition node1 = (XPDefinition) pop();
        AFile node = new AFile(node1);
        return node;
    }

    Node new2()
    {
        PDefinition node2 = (PDefinition) pop();
        XPDefinition node1 = (XPDefinition) pop();
        X1PDefinition node = new X1PDefinition(node1, node2);
        return node;
    }

    Node new3()
    {
        PDefinition node1 = (PDefinition) pop();
        X2PDefinition node = new X2PDefinition(node1);
        return node;
    }

    Node new4()
    {
        TRBrace node5 = (TRBrace) pop();
        XPDefinition node4 = null;
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TPackage node1 = (TPackage) pop();
        APackageDefinition node = new APackageDefinition(node1, node2, node3, node4, node5);
        return node;
    }

    Node new5()
    {
        TRBrace node5 = (TRBrace) pop();
        XPDefinition node4 = (XPDefinition) pop();
        TLBrace node3 = (TLBrace) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TPackage node1 = (TPackage) pop();
        APackageDefinition node = new APackageDefinition(node1, node2, node3, node4, node5);
        return node;
    }

    Node new6()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new7()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new8()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new9()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new10()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new11()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new12()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new13()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new14()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new15()
    {
        PAttribute node2 = (PAttribute) pop();
        XPAttribute node1 = (XPAttribute) pop();
        X1PAttribute node = new X1PAttribute(node1, node2);
        return node;
    }

    Node new16()
    {
        PAttribute node1 = (PAttribute) pop();
        X2PAttribute node = new X2PAttribute(node1);
        return node;
    }

    Node new17()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new18()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new19()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new20()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new21()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new22()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new23()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new24()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new25()
    {
        PFieldList node2 = (PFieldList) pop();
        XPFieldList node1 = (XPFieldList) pop();
        X1PFieldList node = new X1PFieldList(node1, node2);
        return node;
    }

    Node new26()
    {
        PFieldList node1 = (PFieldList) pop();
        X2PFieldList node = new X2PFieldList(node1);
        return node;
    }

    Node new27()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new28()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new29()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new30()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new31()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new32()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new33()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new34()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new35()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new36()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new37()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new38()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new39()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new40()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new41()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = null;
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new42()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new43()
    {
        PModifier node2 = (PModifier) pop();
        XPModifier node1 = (XPModifier) pop();
        X1PModifier node = new X1PModifier(node1, node2);
        return node;
    }

    Node new44()
    {
        PModifier node1 = (PModifier) pop();
        X2PModifier node = new X2PModifier(node1);
        return node;
    }

    Node new45()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new46()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new47()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new48()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new49()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new50()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new51()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new52()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new53()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new54()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new55()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new56()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new57()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new58()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new59()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = null;
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new60()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new61()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new62()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new63()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new64()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new65()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new66()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new67()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = null;
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new68()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new69()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new70()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new71()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = null;
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new72()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new73()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = null;
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new74()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = null;
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new75()
    {
        TRBrace node10 = (TRBrace) pop();
        XPModifier node9 = (XPModifier) pop();
        XPFieldList node8 = (XPFieldList) pop();
        XPAttribute node7 = (XPAttribute) pop();
        TStringLiteral node6 = (TStringLiteral) pop();
        TLBrace node5 = (TLBrace) pop();
        PSuperDeclaration node4 = (PSuperDeclaration) pop();
        TStringLiteral node3 = (TStringLiteral) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TRecord node1 = (TRecord) pop();
        ARecordDefinition node = new ARecordDefinition(node1, node2, node3, node4, node5, node6, node7, node8, node9, node10);
        return node;
    }

    Node new76()
    {
        PItemName node3 = (PItemName) pop();
        TBang node2 = null;
        TExtends node1 = (TExtends) pop();
        ASuperDeclaration node = new ASuperDeclaration(node1, node2, node3);
        return node;
    }

    Node new77()
    {
        PItemName node3 = (PItemName) pop();
        TBang node2 = (TBang) pop();
        TExtends node1 = (TExtends) pop();
        ASuperDeclaration node = new ASuperDeclaration(node1, node2, node3);
        return node;
    }

    Node new78()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAnotherFieldDefinition node3 = null;
        PFieldDefinition node2 = (PFieldDefinition) pop();
        PTypeWithAttributes node1 = (PTypeWithAttributes) pop();
        AFieldList node = new AFieldList(node1, node2, node3, node4);
        return node;
    }

    Node new79()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAnotherFieldDefinition node3 = (XPAnotherFieldDefinition) pop();
        PFieldDefinition node2 = (PFieldDefinition) pop();
        PTypeWithAttributes node1 = (PTypeWithAttributes) pop();
        AFieldList node = new AFieldList(node1, node2, node3, node4);
        return node;
    }

    Node new80()
    {
        PAnotherFieldDefinition node2 = (PAnotherFieldDefinition) pop();
        XPAnotherFieldDefinition node1 = (XPAnotherFieldDefinition) pop();
        X1PAnotherFieldDefinition node = new X1PAnotherFieldDefinition(node1, node2);
        return node;
    }

    Node new81()
    {
        PAnotherFieldDefinition node1 = (PAnotherFieldDefinition) pop();
        X2PAnotherFieldDefinition node = new X2PAnotherFieldDefinition(node1);
        return node;
    }

    Node new82()
    {
        PFieldDefinition node2 = (PFieldDefinition) pop();
        TComma node1 = (TComma) pop();
        AAnotherFieldDefinition node = new AAnotherFieldDefinition(node1, node2);
        return node;
    }

    Node new83()
    {
        XPAttribute node3 = null;
        TStringLiteral node2 = null;
        TIdentifier node1 = (TIdentifier) pop();
        AFieldDefinition node = new AFieldDefinition(node1, node2, node3);
        return node;
    }

    Node new84()
    {
        XPAttribute node3 = null;
        TStringLiteral node2 = (TStringLiteral) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AFieldDefinition node = new AFieldDefinition(node1, node2, node3);
        return node;
    }

    Node new85()
    {
        XPAttribute node3 = (XPAttribute) pop();
        TStringLiteral node2 = null;
        TIdentifier node1 = (TIdentifier) pop();
        AFieldDefinition node = new AFieldDefinition(node1, node2, node3);
        return node;
    }

    Node new86()
    {
        XPAttribute node3 = (XPAttribute) pop();
        TStringLiteral node2 = (TStringLiteral) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AFieldDefinition node = new AFieldDefinition(node1, node2, node3);
        return node;
    }

    Node new87()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAttribute node3 = null;
        PItemName node2 = (PItemName) pop();
        TTilde node1 = (TTilde) pop();
        AExtendModifier node = new AExtendModifier(node1, node2, node3, node4);
        return node;
    }

    Node new88()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAttribute node3 = (XPAttribute) pop();
        PItemName node2 = (PItemName) pop();
        TTilde node1 = (TTilde) pop();
        AExtendModifier node = new AExtendModifier(node1, node2, node3, node4);
        return node;
    }

    Node new89()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAttribute node3 = null;
        PItemName node2 = (PItemName) pop();
        TBang node1 = (TBang) pop();
        AOverrideModifier node = new AOverrideModifier(node1, node2, node3, node4);
        return node;
    }

    Node new90()
    {
        TSemicolon node4 = (TSemicolon) pop();
        XPAttribute node3 = (XPAttribute) pop();
        PItemName node2 = (PItemName) pop();
        TBang node1 = (TBang) pop();
        AOverrideModifier node = new AOverrideModifier(node1, node2, node3, node4);
        return node;
    }

    Node new91()
    {
        TGt node5 = (TGt) pop();
        TStringLiteral node4 = (TStringLiteral) pop();
        TColon node3 = (TColon) pop();
        TIdentifier node2 = (TIdentifier) pop();
        TLt node1 = (TLt) pop();
        AAttribute node = new AAttribute(node1, node2, node3, node4, node5);
        return node;
    }

    Node new92()
    {
        XPAttribute node2 = null;
        PType node1 = (PType) pop();
        ATypeWithAttributes node = new ATypeWithAttributes(node1, node2);
        return node;
    }

    Node new93()
    {
        XPAttribute node2 = (XPAttribute) pop();
        PType node1 = (PType) pop();
        ATypeWithAttributes node = new ATypeWithAttributes(node1, node2);
        return node;
    }

    Node new94()
    {
        TInt node1 = (TInt) pop();
        AIntType node = new AIntType(node1);
        return node;
    }

    Node new95()
    {
        TData node1 = (TData) pop();
        ADataType node = new ADataType(node1);
        return node;
    }

    Node new96()
    {
        TString node1 = (TString) pop();
        AStringType node = new AStringType(node1);
        return node;
    }

    Node new97()
    {
        TFloat node1 = (TFloat) pop();
        AFloatType node = new AFloatType(node1);
        return node;
    }

    Node new98()
    {
        PItemName node1 = (PItemName) pop();
        AUserType node = new AUserType(node1);
        return node;
    }

    Node new99()
    {
        TRBracket node3 = (TRBracket) pop();
        TLBracket node2 = (TLBracket) pop();
        PType node1 = (PType) pop();
        AArrayType node = new AArrayType(node1, node2, node3);
        return node;
    }

    Node new100()
    {
        TIdentifier node1 = (TIdentifier) pop();
        ASimpleItemName node = new ASimpleItemName(node1);
        return node;
    }

    Node new101()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TDot node2 = (TDot) pop();
        PItemName node1 = (PItemName) pop();
        AQualifiedItemName node = new AQualifiedItemName(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 0}, {0, SHIFT, 1}, {1, SHIFT, 2}, },
			{{-1, ERROR, 1}, {19, SHIFT, 6}, },
			{{-1, ERROR, 2}, {19, SHIFT, 7}, },
			{{-1, ERROR, 3}, {21, ACCEPT, -1}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {1, SHIFT, 2}, },
			{{-1, ERROR, 6}, {11, SHIFT, 9}, },
			{{-1, ERROR, 7}, {2, SHIFT, 10}, {11, SHIFT, 11}, {20, SHIFT, 12}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 9}, {0, SHIFT, 1}, {1, SHIFT, 2}, {12, SHIFT, 14}, },
			{{-1, ERROR, 10}, {17, SHIFT, 16}, {19, SHIFT, 17}, },
			{{-1, ERROR, 11}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 23}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, {20, SHIFT, 27}, },
			{{-1, ERROR, 12}, {2, SHIFT, 10}, {11, SHIFT, 37}, },
			{{-1, ERROR, 13}, {11, SHIFT, 39}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 15}, {0, SHIFT, 1}, {1, SHIFT, 2}, {12, SHIFT, 40}, },
			{{-1, ERROR, 16}, {19, SHIFT, 17}, },
			{{-1, REDUCE, 100}, },
			{{-1, REDUCE, 76}, {7, SHIFT, 42}, },
			{{-1, REDUCE, 94}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 96}, },
			{{-1, REDUCE, 97}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 24}, {19, SHIFT, 43}, },
			{{-1, ERROR, 25}, {19, SHIFT, 17}, },
			{{-1, ERROR, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 27}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 46}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, REDUCE, 26}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 31}, {19, SHIFT, 50}, },
			{{-1, REDUCE, 92}, {13, SHIFT, 52}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 98}, {7, SHIFT, 42}, },
			{{-1, ERROR, 34}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 54}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 35}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 58}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 36}, {12, SHIFT, 61}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, ERROR, 37}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 63}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, {20, SHIFT, 64}, },
			{{-1, ERROR, 38}, {11, SHIFT, 68}, },
			{{-1, ERROR, 39}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 69}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, {20, SHIFT, 70}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 77}, {7, SHIFT, 42}, },
			{{-1, ERROR, 42}, {19, SHIFT, 74}, },
			{{-1, ERROR, 43}, {10, SHIFT, 75}, },
			{{-1, ERROR, 44}, {7, SHIFT, 42}, {9, SHIFT, 76}, {15, SHIFT, 24}, },
			{{-1, ERROR, 45}, {7, SHIFT, 42}, {9, SHIFT, 78}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 47}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 80}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 48}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 83}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 49}, {12, SHIFT, 85}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 83}, {15, SHIFT, 24}, {20, SHIFT, 86}, },
			{{-1, ERROR, 51}, {8, SHIFT, 88}, {9, SHIFT, 89}, },
			{{-1, ERROR, 52}, {14, SHIFT, 92}, },
			{{-1, REDUCE, 93}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 56}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 93}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 57}, {12, SHIFT, 95}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 60}, {12, SHIFT, 96}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 42}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 64}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 97}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 65}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 101}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 66}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 104}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 67}, {12, SHIFT, 106}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, ERROR, 68}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 107}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, {20, SHIFT, 108}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 70}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 112}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 71}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 116}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 72}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 119}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 73}, {12, SHIFT, 121}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 101}, },
			{{-1, ERROR, 75}, {20, SHIFT, 122}, },
			{{-1, REDUCE, 89}, },
			{{-1, ERROR, 77}, {9, SHIFT, 123}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 87}, },
			{{-1, ERROR, 79}, {9, SHIFT, 124}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 81}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 125}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 82}, {12, SHIFT, 127}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 84}, {12, SHIFT, 128}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 84}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 85}, {15, SHIFT, 24}, },
			{{-1, ERROR, 88}, {19, SHIFT, 50}, },
			{{-1, REDUCE, 78}, },
			{{-1, REDUCE, 81}, },
			{{-1, ERROR, 91}, {8, SHIFT, 88}, {9, SHIFT, 131}, },
			{{-1, REDUCE, 99}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 94}, {12, SHIFT, 133}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 52}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 98}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 134}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 99}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 137}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 100}, {12, SHIFT, 139}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 102}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 140}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 103}, {12, SHIFT, 142}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 105}, {12, SHIFT, 143}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 108}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 144}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 109}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 148}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 110}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 151}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 111}, {12, SHIFT, 153}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 113}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 154}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 114}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 157}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 115}, {12, SHIFT, 159}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 117}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 160}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 118}, {12, SHIFT, 162}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 120}, {12, SHIFT, 163}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 122}, {16, SHIFT, 164}, },
			{{-1, REDUCE, 90}, },
			{{-1, REDUCE, 88}, },
			{{-1, REDUCE, 38}, },
			{{-1, ERROR, 126}, {12, SHIFT, 165}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 86}, {15, SHIFT, 24}, },
			{{-1, REDUCE, 82}, },
			{{-1, REDUCE, 79}, },
			{{-1, REDUCE, 80}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 135}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 166}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 136}, {12, SHIFT, 168}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 138}, {12, SHIFT, 169}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 141}, {12, SHIFT, 170}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 53}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 145}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 171}, {15, SHIFT, 24}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 146}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 174}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 147}, {12, SHIFT, 176}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 149}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 177}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 150}, {12, SHIFT, 179}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 152}, {12, SHIFT, 180}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 47}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 155}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 181}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 156}, {12, SHIFT, 183}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 158}, {12, SHIFT, 184}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 161}, {12, SHIFT, 185}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 54}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 91}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 39}, },
			{{-1, ERROR, 167}, {12, SHIFT, 186}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 65}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 172}, {3, SHIFT, 19}, {4, SHIFT, 20}, {5, SHIFT, 21}, {6, SHIFT, 22}, {12, SHIFT, 187}, {17, SHIFT, 25}, {18, SHIFT, 26}, {19, SHIFT, 17}, },
			{{-1, ERROR, 173}, {12, SHIFT, 189}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 175}, {12, SHIFT, 190}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 37}, },
			{{-1, ERROR, 178}, {12, SHIFT, 191}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 63}, },
			{{-1, REDUCE, 40}, },
			{{-1, ERROR, 182}, {12, SHIFT, 192}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 41}, },
			{{-1, ERROR, 188}, {12, SHIFT, 193}, {17, SHIFT, 25}, {18, SHIFT, 26}, },
			{{-1, REDUCE, 59}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 75}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 3}, },
			{{-1, 4}, {5, 8}, {15, 8}, },
			{{-1, 13}, {12, 38}, },
			{{-1, 28}, {35, 59}, {48, 59}, {56, 59}, {66, 59}, {72, 59}, {81, 59}, {99, 59}, {102, 59}, {110, 59}, {114, 59}, {117, 59}, {135, 59}, {146, 59}, {149, 59}, {155, 59}, {172, 59}, },
			{{-1, 90}, {91, 132}, },
			{{-1, 51}, {88, 130}, },
			{{-1, 29}, {36, 62}, {49, 62}, {57, 62}, {60, 62}, {67, 62}, {73, 62}, {82, 62}, {84, 62}, {94, 62}, {100, 62}, {103, 62}, {105, 62}, {111, 62}, {115, 62}, {118, 62}, {120, 62}, {126, 62}, {136, 62}, {138, 62}, {141, 62}, {147, 62}, {150, 62}, {152, 62}, {156, 62}, {158, 62}, {161, 62}, {167, 62}, {173, 62}, {175, 62}, {178, 62}, {182, 62}, {188, 62}, },
			{{-1, 30}, {34, 55}, {47, 55}, {53, 55}, {65, 55}, {71, 55}, {77, 55}, {79, 55}, {87, 55}, {98, 55}, {109, 55}, {113, 55}, {129, 55}, {145, 55}, },
			{{-1, 31}, },
			{{-1, 32}, },
			{{-1, 33}, {10, 18}, {16, 41}, {25, 44}, {26, 45}, },
			{{-1, 5}, {9, 15}, },
			{{-1, 34}, {27, 47}, {32, 53}, {37, 65}, {39, 71}, {44, 77}, {45, 79}, {50, 87}, {64, 98}, {68, 109}, {70, 113}, {86, 129}, {108, 145}, },
			{{-1, 35}, {27, 48}, {34, 56}, {37, 66}, {39, 72}, {47, 81}, {64, 99}, {65, 102}, {68, 110}, {70, 114}, {71, 117}, {98, 135}, {108, 146}, {109, 149}, {113, 155}, {145, 172}, },
			{{-1, 36}, {27, 49}, {34, 57}, {35, 60}, {37, 67}, {39, 73}, {47, 82}, {48, 84}, {56, 94}, {64, 100}, {65, 103}, {66, 105}, {68, 111}, {70, 115}, {71, 118}, {72, 120}, {81, 126}, {98, 136}, {99, 138}, {102, 141}, {108, 147}, {109, 150}, {110, 152}, {113, 156}, {114, 158}, {117, 161}, {135, 167}, {145, 173}, {146, 175}, {149, 178}, {155, 182}, {172, 188}, },
			{{-1, 91}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'package', 'record', EOF",
			"expecting: identifier",
			"expecting: EOF",
			"expecting: 'package', 'record', '}', EOF",
			"expecting: '{'",
			"expecting: 'extends', '{', string literal",
			"expecting: 'package', 'record', '}'",
			"expecting: '!', identifier",
			"expecting: 'int', 'data', 'string', 'float', '}', '<', '!', '~', identifier, string literal",
			"expecting: 'extends', '{'",
			"expecting: '.', ';', '{', '[', '<', identifier",
			"expecting: '.', '{'",
			"expecting: '[', '<', identifier",
			"expecting: 'int', 'data', 'string', 'float', '}', '<', '!', '~', identifier",
			"expecting: 'int', 'data', 'string', 'float', '}', '!', '~', identifier",
			"expecting: '}', '!', '~'",
			"expecting: 'int', 'data', 'string', 'float', ',', ';', '}', '<', '!', '~', identifier",
			"expecting: '.', '[', '<', identifier",
			"expecting: ':'",
			"expecting: '.', ';', '<'",
			"expecting: ',', ';', '<', string literal",
			"expecting: ',', ';'",
			"expecting: ']'",
			"expecting: '<', identifier",
			"expecting: string literal",
			"expecting: ';', '<'",
			"expecting: ',', ';', '<'",
			"expecting: '>'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 2, 3, 0, 4, 5, 3, 6, 7, 8, 9, 4, 3, 6, 1, 10, 11, 12, 12, 12, 12, 3, 1, 1, 1, 13, 14, 15, 16, 1, 12, 17, 13, 14, 15, 8, 4, 8, 3, 11, 1, 18, 19, 19, 3, 13, 14, 15, 20, 21, 22, 23, 3, 16, 14, 15, 3, 14, 15, 3, 15, 3, 13, 13, 14, 15, 8, 3, 13, 13, 14, 15, 10, 24, 15, 25, 15, 25, 3, 14, 15, 3, 15, 3, 26, 26, 1, 14, 21, 21, 12, 3, 15, 3, 3, 3, 13, 14, 15, 3, 14, 15, 3, 15, 3, 3, 13, 13, 14, 15, 3, 13, 14, 15, 3, 14, 15, 3, 15, 3, 27, 15, 15, 3, 15, 3, 3, 26, 21, 14, 21, 3, 3, 14, 15, 3, 15, 3, 3, 15, 3, 3, 3, 13, 14, 15, 3, 14, 15, 3, 15, 3, 3, 14, 15, 3, 15, 3, 3, 15, 3, 3, 16, 3, 3, 15, 3, 3, 3, 3, 14, 15, 3, 15, 3, 3, 15, 3, 3, 3, 15, 3, 3, 3, 3, 3, 15, 3, 3, 3, 3, 3, 
        };*/
}
