package test;

import java.util.List;

import step.*;
import step.typedef.*;
import step.encoding.*;

public class ArrayTest extends EncTest
{
  public static void main(String[] args)
  {
    StepObject[] data =
    {
      new StepInt(0x000F),
      new StepInt(0x00FF),
      new StepInt(0x0FFF),
      new StepInt(0xFFFF)
    };

    ArrayTest test  = new ArrayTest();

    FieldDef lengthDef = FieldDef.builder().newFieldDef("length", StepInt.TYPE)
      .addAttribute(new Attribute("encoding", "size=creep,unsigned"))
      .makeFieldDef();

    FieldDef elementDef = FieldDef.builder().newFieldDef("element", Type.v(data[0]))
      .addAttribute(new Attribute("encoding", "size=2,unsigned"))
      .makeFieldDef();

    List fieldDefs = new java.util.ArrayList(2);
    fieldDefs.add(lengthDef);
    fieldDefs.add(elementDef);

    TypeDef typeDef = new TypeDef("int[]", step.typedef.Package.ROOT, fieldDefs, null);

    try
    {
      test.doTest(typeDef, new StepArray(data));
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(TypeDef typeDef, StepArray array)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", typeDef);
    Encoder in  = getInFactory().newEncoder("test", typeDef);

    reset();
    System.out.print(array+" -> ");
    out.encode(array, this);

    reset();
    StepObject tmp = in.decode(this);
    System.out.println(" -> "+tmp+":"+tmp.equals(array));
  }
}
