package test;

import java.util.List;

import step.*;
import step.typedef.*;
import step.encoding.*;

public class ConstantTest extends EncTest
{
  public static void main(String[] args)
  {
    StepObject[] data =
    {
      new StepInt(1),
      new StepInt(1),
      new StepInt(1),
      new StepInt(2),
      new StepInt(1),
      new StepInt(2),
      new StepInt(1)
    };

    ConstantTest test  = new ConstantTest();
    List encAttrs = new java.util.LinkedList();

    try
    {
      encAttrs.add(new Attribute("encoding", "default"));
      test.doTest(Type.v(data[0]), encAttrs, data);

      encAttrs.add(new Attribute("encoding", "repeat")); // override
      test.doTest(Type.v(data[0]), encAttrs, data);

      encAttrs.add(new Attribute("encoding", "constant")); // override
      test.doTest(Type.v(data[0]), encAttrs, data);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(Type type, List encAttrs, StepObject[] data)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", type, encAttrs);
    Encoder in  = getInFactory().newEncoder("test", type, encAttrs);

    for (int i=0; i<data.length; i++)
    {
      reset();
      System.out.print(data[i]+" -> ");
      out.encode(data[i], this);

      reset();
      StepObject tmp = in.decode(this);
      System.out.println(" -> "+tmp+":"+tmp.equals(data[i]));
    }
  }
}
