package test;

import step.*;
import step.encoding.*;

public class DataTest extends EncTest
{
  public static void main(String[] args)
  {
    StepData[] data =
    {
      new StepData(new byte[0]),
      new StepData(new byte[1]),
      new StepData(new byte[127]),
      new StepData(new byte[128]),
      new StepData(new byte[255])
    };

    DataTest test = new DataTest();

    try
    {
      test.doTest(data);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(StepData[] data)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", StepData.TYPE);
    Encoder in  = getInFactory().newEncoder("test", StepData.TYPE);

    for (int i=0; i<data.length; i++)
    {
      reset();
      out.encode(data[i], this);

      reset();
      StepObject tmp = in.decode(this);
      System.out.println(" -> "+tmp.equals(data[i]));
    }
  }
}
