package test;

import step.encoding.*;
import step.util.*;

public abstract class EncTest implements EncodeContext, DecodeContext
{
  private byte[] _bytes = new byte[1024];
  private int    _pos   = 0;

  private EncoderFactory _outFactory, _inFactory;

  protected EncTest()
  {
    _outFactory = new EncoderFactory();
    _inFactory  = new EncoderFactory();
  }

  public void write(Object o)
  {
    byte[] bytes = (byte[]) o;
    for (int i=0; i<bytes.length; i++) _bytes[_pos++] = bytes[i];
    System.out.print(Hex.toString((byte[]) o));
  }

  public void metaWrite(MetaEvent e)
  {
    System.out.print("meta: "+e);
    e.apply(_inFactory);
  }

  public Object read(Object req)
  {
    byte[] bytes = (byte[]) req;
    for (int i=0; i<bytes.length; i++) bytes[i] = _bytes[_pos++];
    return bytes;
  }

  protected void reset() { _pos = 0; }

  protected EncoderFactory getOutFactory() { return _outFactory; }
  protected EncoderFactory getInFactory()  { return _inFactory;  }
}
