package test;

import java.util.List;

import step.*;
import step.typedef.*;
import step.encoding.*;

public class IdTest extends EncTest
{
  public static void main(String[] args)
  {
    StepObject[] data =
    {
      new StepString("Hello"),
      new StepString("Hello"),
      new StepString("Hello"),
      new StepString("World"),
      new StepString("me"),
      new StepString("Hello"),
      new StepString("Hello"),
      new StepString("me"),
      new StepString("World")
    };

    IdTest test = new IdTest();

    List encAttrs = new java.util.ArrayList(1);
    encAttrs.add(new Attribute("encoding", "identifier"));

    try
    {
      test.doTest(Type.v(data[0]), encAttrs, data);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(Type type, List encAttrs, StepObject[] data)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", type, encAttrs);
    Encoder in  = getInFactory().newEncoder("test", type, encAttrs);

    for (int i=0; i<data.length; i++)
    {
      reset();
      System.out.print(data[i]+" -> ");
      out.encode(data[i], this);

      reset();
      StepObject tmp = in.decode(this);
      System.out.println(" -> "+tmp+":"+tmp.equals(data[i]));
    }
  }
}
