package test;

import java.util.List;

import step.*;
import step.typedef.*;
import step.encoding.*;

public class StrideTest extends EncTest
{
  public static void main(String[] args)
  {
    StepObject[] data1 =
    {
      new StepInt(13),
      new StepInt(18),
      new StepInt(23),
      new StepInt(24),
      new StepInt(29),
      new StepInt(12)
    };
    StepObject[] data2 =
    {
      new StepInt(29),
      new StepInt(24),
      new StepInt(23),
      new StepInt(18),
      new StepInt(13),
      new StepInt(12)
    };

    StrideTest test  = new StrideTest();
    List encAttrs = new java.util.LinkedList();

    try
    {
      encAttrs.add(new Attribute("encoding", "stride=5"));
      test.doTest(Type.v(data1[0]), encAttrs, data1);

      encAttrs.add(new Attribute("encoding", "stride=-5")); // override
      test.doTest(Type.v(data2[0]), encAttrs, data2);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(Type type, List encAttrs, StepObject[] data)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", type, encAttrs);
    Encoder in  = getInFactory().newEncoder("test", type, encAttrs);

    for (int i=0; i<data.length; i++)
    {
      reset();
      System.out.print(data[i]+" -> ");
      out.encode(data[i], this);

      reset();
      StepObject tmp = in.decode(this);
      System.out.println(" -> "+tmp+":"+tmp.equals(data[i]));
    }
  }
}
