package test;

import java.util.List;

import step.*;
import step.typedef.*;
import step.encoding.*;

public class StringTest extends EncTest
{
  public static void main(String[] args)
  {
    StepString[] strs =
    {
      new StepString("Hello!"),
      new StepString(""),
      new StepString("\t\b\n"),
      new StepString("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"),
      new StepString("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"),
    };

    StringTest test = new StringTest();
    List encAttrs = new java.util.LinkedList();

    try
    {
      encAttrs.add(new Attribute("encoding", "charset=US-ASCII"));
      test.doTest(encAttrs, strs);

      encAttrs.add(new Attribute("encoding", "charset=UTF-8")); // override
      test.doTest(encAttrs, strs);

      encAttrs.add(new Attribute("encoding", "charset=ISO-8859-1")); // override
      test.doTest(encAttrs, strs);

      ERROR: encAttrs.add(new Attribute("encoding", "charset=xxx")); // override
      ERROR: test.doTest(encAttrs, strs);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  public void doTest(List encAttrs, StepString[] strs)
    throws EncoderException, java.io.IOException
  {
    Encoder out = getOutFactory().newEncoder("test", StepString.TYPE, encAttrs);
    Encoder in  = getInFactory().newEncoder("test", StepString.TYPE, encAttrs);
    
    for (int i=0; i<strs.length; i++)
    {
      reset();
      out.encode(strs[i], this);

      reset();
      StepObject tmp = in.decode(this);
      System.out.println(" -> "+tmp+":"+tmp.equals(strs[i]));
    }
  }
}
